#ifndef U_U_H
#define U_U_H
/*
   ---

   Copyright  1992-2009 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                         all rights reserved
   $Log: u.h,v $
   Revision 1.13  2008/02/05 11:42:16  kraemer
   hpux dl specials

   Revision 1.12  2007/08/01 13:20:52  kraemer
   changed includes for some platform branches

   Revision 1.11  2005/12/16 10:32:02  kraemer
   MacOSX (darwin) support added

   Revision 1.10  2005/11/09 12:47:17  kraemer
   HP-UX 9.1 support

   Revision 1.9  2005/05/17 13:44:26  kraemer
   ultrix added

   Revision 1.8  2001/09/13 12:01:32  kraemer
   strndup-prototype, bool typedefs, amiga redirection, permission bits

   Revision 1.7  1999/12/16 12:40:36  kraemer
   prototypes added

   Revision 1.6  1999/02/02 19:36:30  kraemer
   updated some prototypes

   Revision 1.5  1997/12/15 17:02:47  kraemer
   mips and sunos4 branches

   Revision 1.4  1997/06/16 17:40:02  kraemer
   *** empty log message ***

   Revision 1.3  1997/02/13 18:19:51  kraemer
   *** empty log message ***

 * Revision 1.2  1997/02/03  09:40:53  kraemer
 * *** empty log message ***
 *
*/

                                         /* kludge to obtain HP-UX OS version */
#if defined(__hpux)
#if ! defined(OSVERSION)

#include <sys/privgrp.h>

#if defined(PRIV_PSET)
#define OSVERSION 1111
#elif defined(PRIV_SPUCTL)
#define OSVERSION 1100
#elif defined(PRIV_SERIALIZE)
#define OSVERSION 1000
#elif defined(PRIV_SETRUGID)
#define OSVERSION  900
#endif

#endif
#endif

#if defined(AMIGA) || ( defined(__hpux) && defined(__hp9000s300) )  /* a kludge, would need a differentiator for HP-UX <= 9 */

typedef unsigned long ULONGLONG [2];
#define ULONG2ULONGLONG(ul,ull) (ull)[0] = 0; (ull)[1] = (ul);
#define ULONGLONG2ULONG(ull,ul) (ul) = (ull)[1];

#else

typedef unsigned long long ULONGLONG;
#define ULONG2ULONGLONG(ul,ull) (ull) = (ul);
#define ULONGLONG2ULONG(ull,ul) (ul) = (ull);

#endif

#if defined(AMIGA) || defined(__EMX__)

#else

typedef int BOOL;

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#endif



#ifndef STRNTRIM
#define STRNTRIM(pc,nc) while((nc>0)&&(*pc==' ')){nc--;pc++;}while((nc>0)&&(pc[nc-1]==' '))nc--;
#endif

#ifndef NLBL
#define NLBL(pc) while( *(pc) == ' ' ) (pc)++;
#endif

#ifndef Str
#define Str(v) #v
#endif
#ifndef XStr
#define XStr(v) Str(v)
#endif

#ifndef min
#define min(a,b) ( (a) < (b) ) ? (a) : (b)
#endif

#ifndef max
#define max(a,b) ( (a) > (b) ) ? (a) : (b)
#endif
                                         /* defined(Lynx) */

                                         /* defined(__alpha) too ?? */
#if defined(__osf__) || defined(ultrix) || defined(__EMX__)

#undef  U_BIG_ENDIAN
#define U_LITTLE_ENDIAN

#elif defined(__hpux) || defined(sun) || defined(__mips) || \
      defined(AMIGA) || defined(_AIX) || defined(MVS) || defined(mvs) || defined(__APPLE_CC__)

#define U_BIG_ENDIAN
#undef  U_LITTLE_ENDIAN

#elif defined(__linux__)
                                         /* linux does it itself */ 
#include <endian.h>
#if __BYTE_ORDER == __BIG_ENDIAN
#define U_BIG_ENDIAN
#undef  U_LITTLE_ENDIAN
#else /* __BYTE_ORDER == __LITTLE_ENDIAN */
#undef  U_BIG_ENDIAN
#define U_LITTLE_ENDIAN
#endif

#else
#error You loose, you should not use this computer
#endif

#if defined(AMIGA)
 
#include <stat.h>
#include <dos.h>
#include <exec/memory.h>
#include <proto/dos.h>
#include <proto/exec.h>

                                      /* */
                                      /* aux. structure for timing measurements */
struct STASKTIME {
   struct MsgPort     *mp;
   struct timerequest *io;
   unsigned long lEFreq;  /* E-clock frequency */
//   struct timerequest tr; /* timer device commands */
   struct timeval tv[2];  /* timer results */
};

unsigned short ConfirmWrite( struct Window *, char *);
void MenuLayout( struct Window *, struct Menu * );
void MenuItemCheck( struct Menu *, short, short );
unsigned short *ZZPointer( struct Window *, unsigned short * );
//char *strerror(int);
char *cuserid(char *);
void sleep( int );
void usleep( unsigned long );

#define PATH_MAX FMSIZE
#define L_cuserid 8

#define RemNode Remove

#ifndef S_IRUSR
#define S_IRUSR S_IREAD
#endif
#ifndef S_IWUSR
#define S_IWUSR S_IWRITE
#endif
#ifndef S_IRGRP
#define S_IRGRP S_IREAD
#endif
#ifndef S_IWGRP
#define S_IWGRP S_IWRITE
#endif
#ifndef S_IROTH
#define S_IROTH S_IREAD
#endif
#ifndef S_IWOTH
#define S_IWOTH S_IWRITE
#endif

                                      /* implement 2> redirection */                                      
#ifndef AMIGASTDERRREDIRECT
#if defined(__SASC)
#define AMIGASTDERRREDIRECT(dummy) \
   { int iArg;\
   for ( iArg=0; iArg<argc; iArg++ ) {\
      if ( strncmp( argv[iArg], "2>", 2 ) == 0 ) {\
         __iob[2] = *( (struct __iobuf *) freopen( argv[iArg]+2, "w", stderr ) );\
      }\
   }\
   }
#endif
#endif

#elif defined(__linux__)

#include <sys/stat.h>
#include <unistd.h>
#include <linux/limits.h>

#elif defined(__EMX__)

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <os2emx.h>
#define PATH_MAX CCHMAXPATH
             
//#define STDOUT_FILENO fileno(stdout) 
//#define STDIN_FILENO fileno(stdin) 


#elif defined(MVS) || defined(mvs) 

#else

#include <sys/stat.h>
#include <unistd.h>
#include <limits.h>

#endif

#if defined(AMIGA)
#else
#define iscsym(c) ( ( isalpha(c) || isdigit(c) ) ||(((c) & 127) == 0x5f))

#ifndef __EMX__
char *strnicmp( const char *, const char *, int );
#endif

void strmfn( char *, const char *, const char *, const char *, const char * );
void strsfn( const char *, char *, char *, char *, char * );
void strmfp( char *, const char *, const char * );

#include "exec/types.h"
#include "exec/lists.h"

void NewList( struct List *);
struct Node *RemTail( struct List * );
struct Node *RemHead( struct List * );
struct Node *FindName( struct List *, const char * );
void AddTail( struct List *, struct Node * );

#endif

/*
   --- Process handling stuff --------------------------------------------
*/
struct SFORKMSG {
#if defined(AMIGA)
   struct Message mn;
#endif
   void *pBuf;
   int  nBuf;
   int  iRC;
};

#define MMSGPORT (8+5) /* hex-addr + ".port" */
struct SFORKHANDLE {
#if defined(AMIGA)
   struct ProcID   sID;
   struct MsgPort *pMsgPort;   /* message port for parent-child comm. */
   char cMsgPort[MMSGPORT+1];
#else
   FILE *fp;                   /* pipe */
/*
   pid_t iPID;
*/
#endif
   struct SFORKMSG sMsg;
};

/*
struct SFORKHANDLE *uprcfork( char *[] );
int uprcwait( struct SFORKHANDLE * );
int uprcsend( struct SFORKHANDLE *, void *, int );
int uprcrecv( void *, void **, int *);
void *uprcgtfh( void );
*/

/*
   --- declarations for dynamic loading ----------------------------------
*/
#if defined(_AIX)

typedef void * dynhandle;

#elif defined(__hpux) && ( OSVERSION < 1000 )
#include <dl.h>
typedef shl_t dynhandle;
#elif defined(ultrix)
/*
#include <dlfcn.h>
*/
#define RTLD_NOW 1
typedef void *dynhandle;

#elif defined(sun) || defined(__mips) || defined(__linux__) \
                   || defined(__osf__) || defined(__APPLE_CC__) \
		   || ( defined(__hpux) && ( OSVERSION >= 1000 ) )

#include <dlfcn.h>
typedef void *dynhandle;

#if defined(SUNOS4)
#define RTLD_NOW 1
#define PATH_MAX _POSIX_PATH_MAX 
#endif

#elif defined(__linux__old)
#undef i386
/*
#include <dld.h>
*/
#include <dlfcn.h>
typedef void * dynhandle;

#elif defined(AMIGA)

typedef BPTR dynhandle;

#elif defined(MVS) || defined(mvs) 

typedef void * dynhandle;

#elif defined(__EMX__)

typedef void * dynhandle;

#else
#error You loose, you should not use this computer
#endif

#if defined(SUNOS4)
dynhandle dynload  ();
void     *dynsymbol();
int       dynunload();
#else
dynhandle dynload  ( const char * );
void *dynsymbol( dynhandle, const char * );
int       dynunload( dynhandle );
#endif

/*
   ----------------------------------------------------------------------
*/

#if defined(__EMX__) || defined(AMIGA)
#else
char *strlwr( char *);
char *strupr( char *);
#endif

#if defined(ultrix)
char *strdup ( const char * );
#else
#endif

int MoveFile( const char *, const char * );
char *ufgetln( char *, long *, FILE * );
#if defined(__APPLE_CC__)
#else
#define fgetln ufgetln 
#endif

int fileeq( const char *, const char * );
int iEllipse( short [], short [2][3], short * );

char *strnchr( const char *, int, char);
char *strtrim( char *);

char *strndup ( const char *, size_t );
char *strndup2( const char *, int, const char *, int );
char *strndup3( const char *, int, const char *, int, const char *, int );

char *strdup2( const char *, const char * );
char *strdup3( const char *, const char *, const char * );
char *strdup4( const char *, const char *, const char *, const char * );

void strmcpy ( char *, const char *, int );

char *stristr  ( const char *,      const char *      );
char *stristrn ( const char *,      const char *, int );
char *strnistr ( const char *, int, const char *      );
char *strnistrn( const char *, int, const char *, int );
#if defined(__EMX__) || defined(AMIGA) || defined(__APPLE_CC__)
#else
char *strnstr  ( const char *, int, const char *      );
#endif

int  stricnb ( const char *, const char *);
int  striwld ( const char *, const char *);
int  striwldn( const char *, const char *, int);
void strnupr( char *, int );
char *strrepl( const char *, const char *, char * );
char *uexpfn( const char * );

void *recalloc( void *, int, int );


long ielpst( unsigned long, unsigned long *);
long itaskt( unsigned long, unsigned long *);
int  callmain( void (*)(), char *);

int _pyes( const char *);
int _pcfo( const char *, char *, int );
int _pcf ( const char *, char *, int );
int _pcv ( const char *, char *, int );
int _pcvo( const char *, char *, int );

int cn2vcn( char *, int, char **, int *, int, int );
int cn2vc ( char *, int, char **,        int, int );
int c2vcn ( char *,      char **, int *, int, int );
int c2vc  ( char *,      char **,        int, int );

int swapd( double *, double *, long );
int swapl( unsigned long *, unsigned long *, long );
int swapw( unsigned short *, unsigned short *, long );
int S3702I3E( unsigned long *, unsigned long *, int );

void **dimalloc( int, int, int []);
void dimfree( void **, int, int [] );
void dimcopy( void **, void **, int, int, int []);
void *dimfill( void  *, void **, int, int, int [][3] );

int isign(int);
int _systso(void);
int ichord( short [2], short [2], short, short [2] );
int iarcclip( short [], short [2], short, short, short [][2] );
int isincosd( short, short[] );
short iatan2d( short, short );
int ugetkval( const char *, int, const char *, char **, int *);
int ugetxpr( const char *, int, char **, int *, char **, int *);
void uascebc( unsigned char *, unsigned char *, int, int );
void *utxt2mem( const char * );
int umem2txt( void *, const char * );
int Ustat( const char *, struct stat *);
struct Node *FindIName( struct List *, const char * );
int endian(void);

#endif
